global function l1nexusKeywordInit
global function SearchString
global function ReplaceString

struct{
    array<string> keywords
    array<string> blacklistPlayername

    // Is there any CLIENT func can be used to fetch the uid?
    // player.GetUID() Server side func

    // The uid displays in console once you Click LAUNCH NORTHSTAR. 
    // [info] Trying to authenticate with northstar masterserver for user 100xxxxxxx
    array<string> blacklistPlayerUID

    // Control the mode. Block the message or just replace them.
    string mode
    // Used to replace the keywords.
    string replaceHolder
} file


// Is the UID random int?
// [info] [SERVER SCRIPT] ******** changed the game state..---UID:100xxxxxxx
// [info] [SERVER SCRIPT] ******** started the game countdown..---UID:100xxxxxxx


void function l1nexusKeywordInit()
{
    file.keywords = split(GetConVarString("l1nexus_keyword_chatfilter_keywords"), " ") 
    file.blacklistPlayername = split(GetConVarString("l1nexus_keyword_chatfilter_blacklistPlayername"), " ") 
    file.blacklistPlayername = split(GetConVarString("l1nexus_keyword_chatfilter_blacklistPlayerUID"), " ") 

    file.mode = GetConVarString("l1nexus_keyword_chatfilter_mode")
    file.replaceHolder = GetConVarString("l1nexus_keyword_chatfilter_replaceHolder")

    thread Main()
}

// 我哭 泪洒心中 悲与欢 苍天捉弄
// 我笑 我狂我疯 天与地 风起云涌
// 我醉 一片朦胧 恩和怨 是幻是空
// 我醒 一场春梦 生与死 一切成空
void function Main()
{
    WaitFrame()

    // Works fine in local. Maybe same in server?
    #if CLIENT
    print("Enable KeywordsChatFilter on CLIENT")
    AddCallback_OnReceivedSayTextMessage(ClfilterChat)
    #endif

    #if SERVER
    print("Enable KeywordsChatFilter on SERVER")
    AddCallback_OnReceivedSayTextMessage(ServerfilterChat)
    // AddClientCommandNotifyCallback("chatblock", AddBlockedPlayerName)
    #endif
}

// return start index of a substring in the string
// -1, means not found.
int function SearchString(string targetString, string search)
{
    int index = -1
    int flag = 1
    if (targetString.len() < search.len())  return -1
    if (targetString == search)  return 0

    for(int i; i < targetString.len() - search.len() + 1; i++)
    {
        if (targetString[i] != search[0]) continue
        for(int j = 0; j < search.len(); j++)
        {
            if (targetString[i+j] != search[j])
            {
                flag = 0
            }
        }
        if (flag)
            index = i
    }

    return index
}

// index = int(searchString.find(oldString)) raise int to int error. Why they use var?
string function ReplaceString(string targetString, string oldString, string newString, bool replaceAll, bool ignoreCaps)
{
    if (targetString.len() < oldString.len()) return targetString
    if (targetString == oldString) return newString

    int index = -1
    string searchString = targetString

    if (ignoreCaps)
    {
        searchString = targetString.toupper()
        oldString = oldString.toupper()
    }

    index = SearchString(searchString, oldString)

    print(searchString + " " + oldString + " " + newString + " index "+ index)
    while(index != -1)
    {
        if (index == 0)
        {
            targetString = newString + targetString.slice(oldString.len(), targetString.len())
        }
        else
        {
            targetString = targetString.slice(0, index) + newString + targetString.slice(index + oldString.len(), targetString.len())
        }

        // replace once
        if (!replaceAll)
            break

        // prepare next search
        searchString = targetString.toupper()
        index = SearchString(searchString, oldString)
        // index = type(searchString.find(oldString)) == "int" ? searchString.find(oldString) : -1
    }

    return targetString
}

string function GetReplaceHolderString(int length)
{
    string s = ""

    while(length)
    {
        s += file.replaceHolder
        length = length - 1
    }
    
    return s
}

#if CLIENT
ClClient_MessageStruct function ClfilterChat(ClClient_MessageStruct message)
{
    switch(file.mode)
    {
        case "Block":
            if (file.blacklistPlayername.find(message.playerName) != -1)
                message.shouldBlock = true
            break
        case "Replace":
            // StringReplace(string targetString, string oldString, string newString, bool idk, bool idk)
            foreach(keyword in file.keywords)
                message.message = ReplaceString(message.message, keyword, GetReplaceHolderString(keyword.len()), true, true)
            break
        default:
            if (file.blacklistPlayername.find(message.playerName) != -1)
                message.shouldBlock = true
            foreach(keyword in file.keywords)
                message.message = ReplaceString(message.message, keyword, GetReplaceHolderString(keyword.len()), true, true)
            break
    }
    return message
}
#endif

#if SERVER
ClServer_MessageStruct function ServerfilterChat(ClServer_MessageStruct message)
{
    // Server is able to get the UID
    switch(file.mode)
    {
        case "Block":
            if (file.blacklistPlayername.find(message.player.GetPlayerName()) != -1 || file.blacklistPlayerUID.find(message.player.GetUID()) != -1)
                message.shouldBlock = true
            break
        case "Replace":
            foreach(keyword in file.keywords)
                message.message = ReplaceString(message.message, keyword, GetReplaceHolderString(keyword.len()), true, true)
            break
        default:
            if (file.blacklistPlayername.find(message.player.GetPlayerName()) != -1)
                message.shouldBlock = true
            foreach(keyword in file.keywords)
                message.message = ReplaceString(message.message, keyword, GetReplaceHolderString(keyword.len()), true, true)
            break
    }
    return message
}

// todo: add commands allow player to update lists

// Should work. Not tested on server.
// Meaningless, no way to save to the mod.json.
void function AddBlockedPlayerName(entity player, array<string> args) {
    file.blacklistPlayername.append(args[0])
}
#endif